= nng_http_handler_set_method(3http)
//
// Copyright 2018 Staysail Systems, Inc. <info@staysail.tech>
// Copyright 2018 Capitar IT Group BV <info@capitar.com>
//
// This document is supplied under the terms of the MIT License, a
// copy of which should be located in the distribution where this
// file was obtained (LICENSE.txt).  A copy of the license may also be
// found online at https://opensource.org/licenses/MIT.
//

== NAME

nng_http_handler_set_method - set HTTP handler method

== SYNOPSIS

[source, c]
----
#include <nng/nng.h>
#include <nng/supplemental/http/http.h>

int nng_http_handler_set_method(nng_http_handler *handler, const char *method);
----

== DESCRIPTION

The `nng_http_handler_set_method()` function sets the _method_ that the
_handler_ will be called for, such as "GET" or "POST".
(By default the "GET" method is handled.)
If _method_ is `NULL`, then the request method
is not examined, and the handler will be executed regardless of the
method.

NOTE: The server will automatically call "GET" handlers if the client
sends a "HEAD" request, and will suppress HTTP body data in the responses
sent for such requests.

NOTE: No validation of the _method_ is performed, but HTTP specifications
insist that the actual method sent over the wire be capitalized.

The handler may always examine the actual method used using the
xref:nng_http_req_get_method.3http.adoc[`nng_http_req_get_method()`] function.

== RETURN VALUES

This function returns 0 on success, and non-zero otherwise.

== ERRORS

[horizontal]
`NNG_ENOMEM`:: Insufficient free memory exists.
`NNG_ENOTSUP`:: No support for HTTP in the library.

== SEE ALSO

[.text-left]
xref:nng_http_handler_alloc.3http.adoc[nng_http_handler_alloc(3http)],
xref:nng_http_server_add_handler.3http.adoc[nng_http_server_add_handler(3http)],
xref:nng_http_req_get_method.3http.adoc[nng_http_req_get_method(3http)],
xref:nng.7.adoc[nng(7)]
